"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var NightmareBrowser_1 = require("./browsers/NightmareBrowser");
var PuppeteerBrowser_1 = require("./browsers/PuppeteerBrowser");
function default_1(source, options) {
    if (options === void 0) { options = {}; }
    var Model;
    if (source.launch) {
        Model = PuppeteerBrowser_1.default;
    }
    else if (source.Promise) {
        Model = NightmareBrowser_1.default;
    }
    else {
        throw new Error('Wrong source');
    }
    var mergedOptions = __assign({ show: false, showImages: true, ignoreHTTPSErrors: false, waitTimeout: 3e4, sessionId: null, proxy: {
            host: '',
            port: 0
        }, launchArgs: [] }, options);
    return new Model(source).init(mergedOptions);
}
exports.default = default_1;
//# sourceMappingURL=Ditto.js.map