"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var path = require("path");
var Page_1 = require("../models/Page");
var utils = require("../utils");
var NightmarePage = /** @class */ (function (_super) {
    __extends(NightmarePage, _super);
    function NightmarePage() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    NightmarePage.prototype.html = function () {
        return this.evaluate(function () {
            return document.documentElement.outerHTML;
        });
    };
    NightmarePage.prototype.close = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.ins.end()];
                    case 1:
                        _a.sent();
                        this.ins = null;
                        return [2 /*return*/];
                }
            });
        });
    };
    NightmarePage.prototype.wait = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return __awaiter(this, void 0, void 0, function () {
            var firstArg, timeout, _a, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        firstArg = args[0];
                        if (!(typeof firstArg === 'function')) return [3 /*break*/, 2];
                        timeout = args[1] >= 0 ? args[1] : this.options.waitTimeout;
                        args.splice(1, 1);
                        return [4 /*yield*/, utils.timeout((_a = this.ins).wait.apply(_a, args), timeout)];
                    case 1:
                        _c.sent();
                        return [3 /*break*/, 4];
                    case 2: return [4 /*yield*/, (_b = this.ins).wait.apply(_b, args)];
                    case 3:
                        _c.sent();
                        _c.label = 4;
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    NightmarePage.prototype.waitOne = function (waitings, timeout) {
        return __awaiter(this, void 0, void 0, function () {
            var waitingsString, waitFuncContent, evalFuncContent, index;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        timeout = timeout >= 0 ? timeout : this.options.waitTimeout;
                        waitingsString = waitings.map(function (w) {
                            var ret;
                            if (typeof w === 'string') {
                                ret = "!!document.querySelector('" + w + "')";
                            }
                            else if (typeof w === 'function') {
                                ret = "(" + w.toString() + ")()";
                            }
                            else {
                                throw new Error('Wrong type param in waitOne');
                            }
                            return ret;
                        });
                        waitFuncContent = "return " + waitingsString.join('||');
                        return [4 /*yield*/, this.wait(new Function(waitFuncContent), timeout)];
                    case 1:
                        _a.sent();
                        evalFuncContent = waitingsString.map(function (w, i) { return "if(" + w + "){return " + i + "}"; }).join('\n');
                        return [4 /*yield*/, this.evaluate(new Function(evalFuncContent))];
                    case 2:
                        index = _a.sent();
                        return [2 /*return*/, index];
                }
            });
        });
    };
    NightmarePage.prototype.screenshot = function (filePath) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.ins.screenshot(path.resolve(process.cwd(), filePath))];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    NightmarePage.prototype.setUserAgent = function (ua) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.ins.useragent(ua)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    NightmarePage.prototype.setViewport = function (width, height) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.ins.viewport(width, height)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    return NightmarePage;
}(Page_1.default));
exports.default = NightmarePage;
//# sourceMappingURL=NightmarePage.js.map