import Browser from '../models/Browser';
import NightmarePage from '../pages/NightmarePage';
import { DittoOptions } from '../models/types';
export default class NightmareBrowser extends Browser<NightmarePage> {
    name: string;
    pages: NightmarePage[];
    init(options: DittoOptions): Promise<NightmareBrowser>;
    newPage(): Promise<NightmarePage>;
    close(): Promise<void>;
}
