import { DittoOptions } from "./types";
export default abstract class Page {
    ins: any;
    options: DittoOptions;
    constructor(options: DittoOptions, ins: any);
    isClosed(): boolean;
    close(): Promise<void>;
    goto(url: string): Promise<void>;
    type(selector: string, text: string): Promise<void>;
    click(selector: string): Promise<void>;
    setViewport(width: number, height: number): Promise<void>;
    setUserAgent(ua: string): Promise<void>;
    wait(...args: any[]): Promise<void>;
    waitOne(waitings: Array<any>, timeout: number): Promise<number>;
    evaluate(...args: any[]): Promise<any>;
    abstract html(): Promise<string>;
    abstract screenshot(path: string): Promise<any>;
}
